--[[
    LuaLinker v.0.2 by modsyn 
    contact: modsyn@gmail.com
    site: coming soon (hopefully)
  ]]
require 'lib/net.l'

function follow(host,file)
  local contents=getText(host,file)
  local links = {}
  if contents==nil then
    quit=true
    return nil
  else
    showMsg("Done - parsing bookmark...",1)
    links = getanchors(contents,type)
    for i=1,table.getn(links) do
      if not string.startsWith(links[i],'http://') then
        links[i] = 'http://' .. host .. getParent(file) .. links[i]
      end
    end
  end
  return links,contents
end

while not quit do
  Wlan.term()
  quit=false
  ret_list={}
  dofile "title.lua"
  if quit then
    break
  end
  bookmarks,dirs,types=readopts()
  outdir=dirs[1]
  type=types[1]

  bpress=-1
  while not quit do --bookmark selection...
   page,_,bpress=choose("Select a bookmarked site",bookmarks,1,1)
   if bpress==-1 then
     bpress=showMenu()
     quit = bpress==-1
     if bpress==1 then
       type=choose('Select a file extension',types,nil,1)
     elseif bpress==2 then
       outdir=choose('Choose output directory: '..table.getn(dirs)..' '..outdir,dirs,1,1)
     elseif bpress==3 then
       page = intext("Go to URL:")
       if page ~= '' then
         bpress = 1
         break
       end
     elseif bpress==-1 then
       --pushed start at menu...
       bpress=0
       quit = false
     elseif bpress==4 then  --return to main menu
       quit = false
       bpress=0
       break
     elseif bpress==0 then
       screen:save('page1.png') 
     end
   elseif bpress==1 then
     break
   end
  end  --while not quit (bookmark selection loop)
  
  if page ~= -1 and not quit then
    chooseNetwork()
    clear()
    if not string.startsWith(page,"http://") then
      page="http://" .. page
    end
    local host,file=spliturl(page)
    
    while not quit do
      links,contents = follow(host,file)
      bpress=-1
      while bpress~= 1 and not quit do --link chooser...
        chosen,idx,bpress,ret_list=choose("Select a link (" .. table.getn(links) .. ")     [R: change mode]",links,1)
        if bpress==-1 then  --hit start for menu options
          bpress=showMenu()
          quit = bpress==-1
          if bpress==1 then  --file extension (requires resorting of contents)
            type=choose('Select a file extension',types,nil,1)
            local anch = getanchors(contents,type)
            for i=1,table.getn(anch) do
              if not string.startsWith(anch[i],'http://') then
                anch[i] = 'http://' .. host .. getParent(file) .. anch[i]
              end
            end
            links=anch
            bpress=-1
          elseif bpress==2 then  --output directory chooser
            outdir=choose('Choose output directory: '..table.getn(dirs)..' '..outdir,dirs,1,1)
          elseif bpress==3 then  --manual entry
            if not mode then
              chosen = intext("Go to URL:")
              if chosen ~= '' then
                bpress = 1
                break
              end
            else
              showMsg('Not valid in download mode!')
            end
          elseif bpress==-1 then
            --pushed start at menu...
            bpress=0
            quit = false
          elseif bpress==4 then  --return to main menu
            quit = false
            bpress=0
            break
          end
        end
      end --end link chooser loop
      if bpress ~= -1 then --follow link/download 
        if mode then  --download mode
          if ret_list ~= nil then
            if table.getn(ret_list)>0 then
              for i=1,table.getn(ret_list) do
                host,file=spliturl(ret_list[i])
                name=getName(file)
                if string.equals(name,"/") or string.equals(name,"") then
                  name = 'output.' .. type
                end
                if not quit then
                  showMsg('Init connection with ' .. host .. '...')
                  local conn=connect(host)
                  a=getFile(conn,file,outdir..name)
                end
              end
            else
              chosen = links[idx]
              host,file=spliturl(chosen)
              name=getName(file)
              if not quit then
                showMsg('Initializing connection with '.. host .. '...')
                local conn=connect(host)
                a=getFile(conn,file,outdir..name)
              end
            end
          else -- if ret_list is nil, do nothing...
          end
          break
        else  --follow links mode......
          if not string.startsWith(chosen,"http://") then
            chosen="http://" .. page
          end
          host,file=spliturl(chosen)
          showMsg("Following link: " .. chosen,3000)
        end --folow or download if/else clause
      end --end follow link/download loop
    end
  else
    --showMsg("Network selection aborted")
    quit = false
  end
end 
quit=false
Wlan.term()
showMsg("Goodbye!",400)