--[[
///////////////////////////////////////////////////////////////////////////////
 'TwinTail Trainer'

 Copyright(c) 2005, ema.
///////////////////////////////////////////////////////////////////////////////
]]--

-------------------------------------------------------------------------------
require "filer.lc"
require "pad.lc"
require "twintail.lc"

math.randomseed(os.time())

while true do
  local tti = TwinTail.new(2)
  local White = Color.new(255, 255, 255)
  local Green = Color.new(  0, 255,   0)
  local Yellow = Color.new(255, 255,   0)
  local OnWindows = string.find(System.currentDirectory(), "/cygdrive/")
  local fln

  if OnWindows then
    fln = "data/q_both1.txt"
  else
    fln = Filer("data", false)
  end
  if not fln then break end

  local qtbl = {}
  for Data in io.lines(fln) do
    table.insert(qtbl, Data)
  end

  local buf  = ""
  local ans  = ""
  local nChar= 0
  local col  = White
  local timer= Timer.new()

  while true do
    local l = string.len(buf)
    Pad:Update()

    if ans == "" then
      local iq = math.floor(math.random() * table.getn(qtbl)) + 1
      buf   = ""
      nChar = 0
      ans   = qtbl[iq]
      while string.len(ans) < 40 do
        iq = math.floor(math.random() * table.getn(qtbl)) + 1
        ans = ans .. " " .. qtbl[iq]
      end
      col = White
      timer:reset()
    end

    screen:clear()
    screen:print(2, 2, "["..fln.."]", White)
    screen:print(4, 40, ans, White)
    screen:print(4, 50, buf, White)
    screen:fillRect(4+l*8, 50, 1, 8, Green)

    if Pad.St then break end

    if Pad.R1 then
      local In = tti:Update()
      tti:Draw(screen, 392, 228)

      if In then
        if nChar==0 then
          timer:start()
        end
        if In=="\n" then
          ans = ""
        elseif In=="\b" then
          buf=string.sub(buf, 1, l-1)
        else
          nChar=nChar+1
          buf=buf..In
          if buf==ans then
            timer:stop()
            col = Yellow
          end
        end
      end
    end

    screen:print(0, 80, nChar*60000/(timer:time()+1), col)
    screen.waitVblankStart()
    screen.flip()
  end
end