--load necessary libs for utilities
require "lib/pad.lc"
require "lib/string.l"
require 'lib/twintail.l'

--pad = Pad.new()
white = Color.new(255, 255, 255)
green = Color.new(0,200,0)
black = Color.new(0,0,0)
blue = Color.new(30,30,230)
teal = Color.new(0,200,200)

--black = teal

yellow= Color.new(255, 255, 0)
red= Color.new(255, 0, 0)
ms = Font.createProportional()
fw=10
ms:setPixelSizes(0, fw)
os = Image.createEmpty(480, 272)
os:clear(black)
selected=1
chosen=false
state=0
quit=false
y=fw
x=0
max=1
myfont=System.currentDirectory().."/Gemelli.ttf"
mode=true  --true is download/false is follou

function gprintln(text,color,wait)
  gprint(text.."\n",color,wait)
end

function page(text,delim)
  if delim == nil then
    delim = '\n'
  end
  if text == nil then
    return nil
  else
    back=Image.createEmpty(480,512)
    back:clear(white)
    lines = string.split(text,delim)
    for i=1,table.getn(lines) do
      gprintln(lines[i])
      wait()
    end
  end
end

--Taken from PSP-HTTPD (modified)
function gprint(text,color,wait)
  if color==nil then
    color=yellow
  end
  if wait == nil then
    wait=true
  end
  if y >= 272-fw then
    os:clear(black)
    y = fw
  end
  for i = 1, string.len(text) do
    char = string.sub(text, i, i)
    if char == "\n" then
      y = y + fw
      x = 0
    elseif char ~= "\r" then
      if char == "\b" then
        x = x - 1
        os:fontPrint(ms,x,y," ",color)
      else
        os:fontPrint(ms,x, y, char, color)
        x = x + fw
        if x >= 480 then
          y = y + fw
          x = 0
        end
      end
    end
  end
  screen:blit(0, 0, os)
  if wait then screen.waitVblankStart() end
  screen.flip()
end

function cprint(title,lines,marks,idx,ex)
  local t=8
  local l=0
  local ss=20
  local lines_2 = lines
  local st=0
  local color=white

  --max isnt set then set it
  if max==1 then
    max=ss+1
  end

  --index got larger than max so set start point
  if idx>max then
    st=max-ss
  end

  --up max if index is greater
  if idx>max then
    max = idx
  end

  st = max-ss

  --adjust max when index goes low
  if idx<st then
    max = st+ss-1
    st = idx
  end

  screen:clear()
  os:print(0,t,title,yellow)
--  os:print(0,t,'idx: '..idx..'  max: '..max..'  ss: '..ss..'  st '..st,yellow)

  --print the list
  for j=st,(st+ss) do
    local str = nil
    if j>table.getn(lines_2) then
      break
    end
    p= ((j-st+2)*t) +t
    if j==idx then 
      color=red
    else
      color=white
    end
    if ex == nil then
      str=getName(lines_2[j])
    end
    if marks[j] then
      str=' '..getName(lines_2[j])
    end
    os:print(16, p, str or lines_2[j], color)
  end
  os:fillRect(3,(ss*t)+42,470,60,blue)
  os:fillRect(8,(ss*t)+47,460,50,black)
  os:print(13, (ss*t)+50, 'Hit Start to access menu', white)
  os:print(13, (ss*t)+65, getinfo(), yellow)
  if mode then
    os:print(230, (ss*t)+50, 'Mode: Download', yellow)
  else
    os:print(230, (ss*t)+50, 'Mode: Follow Link', yellow)
  end
  screen:blit(0,0,os)
  screen.flip()
end

function clear()
    y=8
    x=0
    os:clear(black)
end

function reset()
    y=8
    x=0
end

function showMsg(msg,tmr)
  clear()
  local fw=8
  local fw2=fw*2
  local boxsize = math.floor(string.len(msg)*fw)+ fw
  if boxsize>512 then
    boxsize=512
  end
  if fw2>512 then
    fw2 = 512
  end
  box=Image.createEmpty(boxsize,fw2)
  box:clear(Color.new(30,30,230))
  box:print(2,2,msg,white)
  os:blit((480-boxsize)/2,(272-30)/2,box)
  screen:blit(0, 0, os)
  screen.flip()
  screen:waitVblankStart()
  if not tmr then
    System.sleep(1000)
  else
    System.sleep(tmr)
  end
  
end

function confirm(msg)
--  local pad=Pad.new()
  local fw=8
  if msg == nil then
    msg = 'Are you sure?'
  end
  local boxsize = math.floor(string.len(msg)*fw)+ fw
  if  boxsize<13*fw then
    boxsize=13*fw
  end
  box=Image.createEmpty(boxsize,50)
  box:clear(Color.new(30,30,230))

  while true do
    box:print(2,2,msg,white)
    box:print((boxsize-(fw*4))/2,(fw*2),"X=Yes",yellow)
    box:print((boxsize-(fw*4))/2,fw*3,"0=No",yellow)
    os:blit((480-boxsize)/2,(272-30)/2,box)
    screen:blit(0, 0, os)
    screen.flip()
    screen:waitVblankStart()
    --pad:Update()
    Pad:Update()
    if Pad.tRd then
       clear()
       return true
    elseif Pad.tRr then
       clear()
       return false
    end
  end
end

function showMenu()
  local modes = { 'download', 'follow link' }
  local ops = { 'File Extensions', 'Download Directory', 'Manual Entry (for bookmarks)','Back to Start Page' }
  local done = nil
  while not done do
    local sel,idx,bt=choose('Menu Options',ops)
    if bt == -1 then
      done = true
      return -1
    else
      return idx
    end
  end
end

function intext(prompt)
  local buf  = "http://"
  local ans  = ""
  local nChar= 0
  local msg = prompt or 'Text Input'
  local tti = TwinTail.new(1)
  local White = Color.new(255, 255, 255)
  local Green = Color.new(  0, 255,   0)
  local Yellow = Color.new(255, 255,   0)
  local boxsize = math.floor(string.len(msg)*fw*3)+ fw
  local topc = (480-boxsize)/2
  local leftc = (272-30)/2
  local inp = false
  local qk = false
  local qinps = { 'www.', '.com', '.org', '.net', '.edu', 'index.html', 'index.php' }

  while true do
    local l = string.len(buf)
    Pad:Update()

    screen:clear()

    screen:fillRect(topc, leftc, boxsize, 30, blue)
    screen:print(topc+fw, leftc, msg, yellow)
    screen:print(topc+(fw*2), leftc+fw, buf, White)

    screen:print(40, 220, 'Input system: TTLDE by ema', White)
    screen:print(40, 230, 'R: Toggle Input', White)
    screen:print(40, 240, 'L: Quick Inputs', White)
    screen:print(24, 250, 'Sel: Add input to bookmarks', White)

    if Pad.tSt then
      if qk then
        qk = false
        Pad:Update()
      else
        if string.len(buf)<=7 then
          buf = ''
        end
        break
      end
    end

    if Pad.tSl then
      local prt = confirm('Add ' .. buf .. ' to bookmarks?')
      if prt then
        addbkmk(buf)
      end
    end

    if Pad.tR1 then
      inp = inp==false
    end

    if Pad.tL1 and not inp then
      qk = true
      if qk then
        local sel,_,bt = choose('Quick Inputs',qinps)
        if bt==1 then
          buf = buf .. sel
          qk = false
        elseif bt==-1 then
          quit = false
        else
          Pad:Update()
        end
      end
    end

    if inp then
    end

    if inp then
      local In = tti:Update()
      tti:Draw(screen, 392, 228)

      if In then
        if nChar==0 then
        end
        if In=="\n" then
          ans = ""
        elseif In=="\b" then
          buf=string.sub(buf, 1, l-1)
        else
          nChar=nChar+1
          buf=buf..In
          if buf==ans then
          end
        end
      end
    end

    screen.waitVblankStart()
    screen.flip()
  end
  return buf
end

function addbkmk(buf)
  local of = io.open('bookmarks.inf','a')
  if of then
    of:write(buf .. '\n')
    of:close()
  end
end

function setMode()
  mode = (mode==false)
end

function readopts()
  local dirs={}
  local filename="bookmarks.inf"
  local file=io.open(filename,"r")
  local bookmarks={}
  local types={}
  local dirs={'ms0:/PSP/MUSIC/','ms0:/PSP/PHOTO/','ms0:/','./'}
  dirs = {}

  if file then
    repeat
      if line ~= nil then
        table.insert(bookmarks,string.trim(line))
      end
      line = file:read()
    until line==nil
  end
  filename="types.inf"
  file=io.open(filename,"r")

  if file then
    repeat
      if line ~= nil then
        table.insert(types,string.trim(line))
      end
      line = file:read()
    until line==nil
  end
  filename="dirs.inf"
  for line in io.lines(filename) do
    table.insert(dirs,string.trim(line))
  end
  return bookmarks,dirs,types
end

function getinfo()
  local str = 'File type: ' .. type .. '  OutDir: ' .. outdir
  return str
end

function wait()
  --local pad = Pad.new()
  gprintln('Push start to continue...')
  while true do
    Pad:Update()
    if Pad.tSt then
      break
    end
  end
end

function fileExists(file)
  t, msg = io.open(file, "r")
     if not t then return false end
     t:close()
  return true
end

function copyfile(f1,f2)
  gprintln('copy '..f1)
  gprintln('  to '..f2)
  local inf=io.open(f1,"r")
  if inf then
    local outs=io.open(f2,"w")
    if outs then
      local buf = inf:read("*a")
      outs:write(buf)
      inf:close()
      outs:close()
  gprintln('ok '..f2)
  wait()
      return 1
    else
  gprintln('couldnt open '..f2)
  wait()
      return nil
    end
  else
  gprintln('couldnt open '..f1)
  wait()
    return nil
  end
end

function setconfigs()
  local configs={}
  local file='conf.inf'
  for line in io.lines(file) do
    if string.contains(line,'=') then
      local parts=string.split(line,'=')
      configs[parts[1]]=parts[2]
    end
  end
  return configs
end

function getParent(path)
  return string.sub(path,1,string.lastIndexOf(path,'/'))
end

function parse(text,ext)
  local locs = {  }
  local url = ""
  local host=''
  local filename=''
  local lines=string.split(text,"\n")
  for key,line in lines do
    if string.contains(line,"http(.+%.)"..ext) then
      i,j=string.find(line,"http(.+%.)"..ext)
      url,cnt = string.sub( line, i,j )
      --get rid of the stuff in front of http://......ext that starts with 'http://'
      urls = string.split(url,"http://")
      if table.getn(urls)>1 then
        url = 'http://' .. urls[table.getn(urls)]
      end
      fchar = string.sub(url,1,1)
      if string.equals( fchar, "\"" ) or string.equals( fchar, "'" ) then
        url = "http:"..string.sub(url,2,-1)
      end
      if string.len(url)>0 then
        table.insert(locs,url)
      end
    end
  end
  return locs
end


function choose(title,list,single,ex)
 max=1
 --local pad = Pad.new()
 local sel=1
 local multi=false
 local marks={}
 local names={}
 for j=1,table.getn(list) do
   table.insert(marks,false)
 end
 clear()
 cprint(title,list,marks,sel,ex)
  while true do
  --System.sleep(1000)
  Pad:Update()
  if Pad.tLd then
   if sel<table.getn(list) then
    sel=sel+1
   else
    sel=1
   end
    clear()
    cprint(title,list,marks,sel,ex)
  elseif Pad.tR1 then
    setMode()
    cprint(title,list,marks,sel,ex)
  elseif Pad.tLu then
   if sel>1 then
    sel=sel-1
   else
    sel=table.getn(list)
   end
    clear()
    cprint(title,list,marks,sel,ex)
  elseif Pad.tLl and single then
    clear()
    marks[sel]=false
    local count=0
    for i=1,table.getn(marks) do
      if marks[i] then
        count = 1
        break
      end
    end
    if count>0 then
      multi=false
    end
    if sel>1 then
     sel=sel-1
    end
    cprint(title,list,marks,sel,ex)
  elseif Pad.tLr and single then
    clear()
    marks[sel]=true
    multi=true
    if sel<table.getn(list) then
     sel=sel+1
    end
    cprint(title,list,marks,sel,ex)
  elseif Pad.tRd then
   clear()
   local markedList = {}
   if multi then
     for i=1,table.getn(list) do
       if marks[i] then
         table.insert(markedList,list[i])
       end
     end
   end
   return list[sel],sel,1,markedList
  elseif Pad.tRu then
   clear()
   return list[sel],sel,3
  elseif Pad.tRl then
   clear()
   return list[sel],sel,2
  elseif Pad.tSt then
   quit = true
   clear()
   return -1,-1,-1
  elseif Pad.tSl then
   clear()
   return list[sel],sel,0
  end
 end
end